<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/TOC.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/TOC.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/TOC.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;Table of Contents classes&quot;&quot;&quot;</span></span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">import</span> re</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/Linker.html">Linker</a>:</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Abstract class for linking declarations. This class has only one</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-string">   method, link(decl), which returns the link for the given declaration. This</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">   is dependant on the type of formatter used, and so a Linker derivative</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-string">   must be passed to the TOC upon creation.&quot;&quot;&quot;</span></span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/Linker.html#link">link</a>(decl): <span class="py-keyword">pass</span></span>
<a id="line22"></a><span class="lineno"> 22</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html">TOC</a>(ASG.Visitor):</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Maintains a dictionary of all declarations which can be looked up</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-string">   to create cross references. Names are fully scoped.&quot;&quot;&quot;</span></span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">   <span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC/Entry.html">Entry</a>:</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Struct for an entry in the table of contents.</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-string">      Vars: link, lang, type (all strings)</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="py-string">      Also: name (scoped)&quot;&quot;&quot;</span></span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">      <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC/Entry.html#__init__">__init__</a>(self, name, link, lang, type):</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">         self.name = name</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">         self.link = link</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">         self.lang = lang</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">         self.type = type</span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#__init__">__init__</a>(self, linker, verbose = False):</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">      <span class="py-string">&quot;&quot;&quot;linker is an instance that implements the Linker interface and is</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="py-string">      used to generate the links from declarations.&quot;&quot;&quot;</span></span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">      self.__toc = {}</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">      self.linker = linker</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">      self.verbose = verbose</span>
<a id="line46"></a><span class="lineno"> 46</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#keys">keys</a>(self): <span class="py-keyword">return</span> self.__toc.keys()</span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#lookup">lookup</a>(self, name):</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">      name = tuple(name)</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">      <span class="py-keyword">if</span> self.__toc.has_key(name): <span class="py-keyword">return</span> self.__toc[name]</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">      <span class="py-keyword">if</span> self.verbose <span class="py-keyword">and</span> len(name) &gt; 1:</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: TOC lookup of&quot;</span>,name,<span class="py-string">&quot;failed!&quot;</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">      <span class="py-keyword">return</span> None</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#size">size</a>(self): <span class="py-keyword">return</span> len(self.__toc)</span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">   __getitem__ = lookup</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#insert">insert</a>(self, entry):</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">      self.__toc[tuple(entry.name)] = entry</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#store">store</a>(self, file):</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">      <span class="py-string">&quot;&quot;&quot;store the table of contents into a file, such that it can be used later when cross referencing&quot;&quot;&quot;</span></span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">      fout = open(file, <span class="py-string">'w'</span>)</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">      nocomma = <span class="py-keyword">lambda</span> str: str.replace(<span class="py-string">&quot;&amp;&quot;</span>,<span class="py-string">&quot;&amp;amp;&quot;</span>).replace(<span class="py-string">&quot;,&quot;</span>,<span class="py-string">&quot;&amp;2c;&quot;</span>)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">      <span class="py-keyword">for</span> name <span class="py-keyword">in</span> self.__toc.keys():</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">         scopedname = nocomma(<span class="py-string">'::'</span>.join(name))</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">         lang = self.__toc[tuple(name)].lang</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">         link = nocomma(self.__toc[tuple(name)].link)</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">         fout.write(scopedname + <span class="py-string">&quot;,&quot;</span> + lang + <span class="py-string">&quot;,&quot;</span> + link + <span class="py-string">&quot;\n&quot;</span>)</span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#load">load</a>(self, resource):</span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">      args = resource.split(<span class="py-string">'|'</span>)</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">      file = args[0]</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">      <span class="py-keyword">if</span> len(args) &gt; 1: url = args[1]</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">      <span class="py-keyword">else</span>: url = <span class="py-string">&quot;&quot;</span></span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">      fin = open(file, <span class="py-string">'r'</span>)</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">      line = fin.readline()</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">      recomma = <span class="py-keyword">lambda</span> str: re.sub(<span class="py-string">'&amp;2c;'</span>, <span class="py-string">','</span>, str)</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">      <span class="py-keyword">while</span> line:</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">         <span class="py-keyword">if</span> line[-1] == <span class="py-string">'\n'</span>: line = line[:-1]</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">         scopedname, lang, link = line.split(<span class="py-string">','</span>)</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">         scopedname, link = recomma(scopedname), recomma(link)</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">         param_index = scopedname.find(<span class="py-string">'('</span>)</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">         <span class="py-keyword">if</span> param_index &gt;= 0:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            name = scopedname[:param_index].split(<span class="py-string">'::'</span>)</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            name = name[:-1] + [name[-1]+scopedname[param_index:]]</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">            name = scopedname.split(<span class="py-string">'::'</span>)</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">         <span class="py-keyword">if</span> len(url): link = <span class="py-string">'/'</span>.join([url, link])</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">         entry = TOC.Entry(name, link, lang, <span class="py-string">&quot;decl&quot;</span>)</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">         self.insert(entry)</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">         line = fin.readline()</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/TOC/TOC.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">      file = decl.file</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">      entry = TOC.Entry(decl.name, self.linker.link(decl),</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                        file <span class="py-keyword">and</span> file.annotations[<span class="py-string">'language'</span>] <span class="py-keyword">or</span> <span class="py-string">''</span>, <span class="py-string">'decl'</span>)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">      self.insert(entry)</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
